package ShowXPath.TreeNode;

import ShowXPath.StackNode.*;
import java.util.*;

public class LAttribute extends LTreeNode
{
	private LQname _qname;
	private String _value;
	private LTreeNode _parent;
	private String _original_name;
	private static String _type = "LAttribute";

	public String getLang()
	{
		return _parent.getLang();
	}

	public LRoot getRoot()
	{
		return _parent.getRoot();
	}

	public LTreeNode getParent()
	{
		return _parent;
	}

	public String type()
	{
		return _type;
	}

	public LAttribute(String name, String value, LTreeNode parent,
										Hashtable spaces)
	{
		_qname = new LQname(name, spaces);
		_original_name = name;
		_value = value;
		_parent = parent;
		setID();
	}

	public String getStringValue()
	{
		return _value; // Should normalize before returning
	}

	public String getName()
	{
		return _qname.getLocalName() + ":" + _qname.getURI();
	}
	
	public String getLocal_name()
	{
		return _qname.getLocalName();
	}

	public String getNamespace()
	{
		return _qname.getNamespace();
	}

	public String getNamespace_uri()
	{
		return _qname.getURI();
	}

	public String toString()
	{
		return _original_name + "='" + _value + "'";
	}
	
	public String getNodeStringValue()
	{
		return "{" + _order + "}" + _original_name + "=" + "'" + _value + "'";
	}

	public LNodeset parent()
	{
		LNodeset list = new LNodeset();
		list.add(_parent);
		return list;
	}

	public LNodeset child()
	{
		LNodeset list = new LNodeset();
		return list;
	}

	public LNodeset ancestor()
	{
		return parent();
	}

	public LNodeset self()
	{
		LNodeset list = new LNodeset();
		list.add(this);
		return list;
	}

	public LNodeset ancestor_or_self()
	{
		LNodeset list = parent();
		list.add(this);
		return list;
	}

	public LNodeset descendent()
	{
		LNodeset list = new LNodeset();
		return list;
	}

	public LNodeset descendent_or_self()
	{
		return self();
	}

	public LNodeset attribute()
	{
		LNodeset list = new LNodeset();
		return list;
	}

	public LNodeset following()
	{
		LNodeset list = new LNodeset();
		return list;
	}

	public LNodeset following_sibling()
	{
		LNodeset list = new LNodeset();
		return list;
	}

	public LNodeset preceding()
	{
		LNodeset list = new LNodeset();
		return list;
	}

	public LNodeset preceding_sibling()
	{
		LNodeset list = new LNodeset();
		return list;
	}

	public LNodeset namespace()
	{
		LNodeset list = new LNodeset();
		return list;
	}

	public String showNode()
	{
		return toString();
	}
	
}
