package ShowXPath.TreeNode;

import java.util.*;
import ShowXPath.StackNode.*;

public class LText extends LTreeNode
{
	private String _value;
	private LTreeNode _parent;
	private final static String _type = "LText";

	public String getLang()
	{
		return _parent.getLang();
	}

	public LRoot getRoot()
	{
		return _parent.getRoot();
	}

	public void appendText(String text)
	{
		_value = _value + text;
	}

	public LTreeNode getParent()
	{
		return _parent;
	}

	public String type()
	{
		return _type;
	}

	public LText(LTreeNode parent)
	{
		_parent = parent;
		setID();
	}

	public LText(String text, LTreeNode parent)
	{
		_parent = parent;
		_value = text;
		setID();
	}

	public String getStringValue()
	{
		return _value;
	}

	public String getName()
	{
		return "";
	}

	public String getLocal_name()
	{
		return "";
	}

	public String getNamespace()
	{
		return "";
	}

	public String getNamespace_uri()
	{
		return "";
	}
	
	public void add(String string)
	{
		_value = string;
	}

	public String toString()
	{
		return normalize();
	}

	public String getNodeStringValue()
	{
		return "{" + _order + "}" + _value;
	}
	public LNodeset parent()
	{
		LNodeset list = new LNodeset();
		list.add(_parent);
		return list;
	}

	public LNodeset child()
	{
		LNodeset list = new LNodeset();
		return list;
	}

	public LNodeset ancestor()
	{
		LNodeset list = _parent.ancestor_or_self();
		return list;
	}

	public LNodeset self()
	{
		LNodeset list = new LNodeset();
		list.add(this);
		return list;
	}

	public LNodeset ancestor_or_self()
	{
		LNodeset list = ancestor();
		list.add(this);
		return list;
	}

	public LNodeset descendent()
	{
		LNodeset list = new LNodeset();
		return list;
	}

	public LNodeset descendent_or_self()
	{
		LNodeset list = new LNodeset();
		list.add(this);
		return list;
	}

	public LNodeset attribute()
	{
		LNodeset list = new LNodeset();
		return list;
	}

	public LNodeset following()
	{
		LNodeset list = root();
		list = ((LTreeNode)list.getFirst()).descendent();
		ListIterator i = list.listIterator();
		while (i.hasNext())
		{
			LTreeNode n = (LTreeNode)i.next();
			if (n.getOrder() <= _order)
			{
				i.remove();
			}
		}
		return list;
	}

	public LNodeset following_sibling()
	{
		LNodeset list = _parent.child();
		Iterator i = list.listIterator();
		while (i.hasNext())
		{
			LTreeNode n = (LTreeNode)i.next();
			if (n.getOrder() <= _order)
			{
				i.remove();
			}
		}
		return list;
	}

	public LNodeset preceding()
	{
		LNodeset list = root();
		list = ((LTreeNode)list.getFirst()).descendent();
		ListIterator i = list.listIterator();
		while (i.hasNext())
		{
			LTreeNode n = (LTreeNode)i.next();
			if (n.getOrder() >= _order)
			{
				i.remove();
			}
		}
		return list;
	}

	public LNodeset preceding_sibling()
	{
		LNodeset list = _parent.child();
		Iterator i = list.listIterator();
		while (i.hasNext())
		{
			LTreeNode n = (LTreeNode)i.next();
			if (n.getOrder() >= _order)
			{
				i.remove();
			}
		}
		return list;
	}

	private void print(String string)
	{
		//System.out.println("In LText: " + string);
	}

	public LNodeset namespace()
	{
		LNodeset list = new LNodeset();
		return list;
	}

	public String showNode()
	{
		return toString();
	}
	
	public String normalize() {
		String s = _value;
		StringBuffer str = new StringBuffer();

		int len = (s != null) ? s.length() : 0;
		for ( int i = 0; i < len; i++ ) {
			char ch = s.charAt(i);
			switch ( ch ) {
				case '<': {
					str.append("&lt;");
					break;
				}
				case '>': {
					str.append("&gt;");
					break;
				}
				case '&': {
					str.append("&amp;");
					break;
				}
				case '"': {
					str.append("&quot;");
					break;
				}
				case '\r':
					str.append("&#xD;");
					break;
				case '\n':
					str.append("&#xA;");
					break;
				default: {
					if (ch == '\u00A0' || ch > '\u00FE')
					{
						print("Printing long hand for characters: " +
															 "&#" + Integer.toString(ch) + ";");
						str.append("&#");
						str.append(Integer.toString(ch));
						str.append(';');
					}
					else
					{
						str.append(ch);
					}
				}
			}
		}

		return (str.toString());

	}
}
